using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Data;


namespace SQLinjection
{    
    /// <summary>
    /// this class inherits the common connection class and is used to pass commands back to the database
    /// </summary>
    internal class DataAccessType : CommonConnection
    {

        #region datasets
        /// <summary>
        /// this method passes in a sqlcommand object and returns a sqlDataAdapter object
        /// </summary>
        /// <param name="oCmd"></param>
        /// <returns></returns>
        
        internal protected SqlDataAdapter ExecuteDataSetRequest(SqlCommand oCmd) {
            SqlConnection oConn = null;
            SqlDataAdapter oAdapter = new SqlDataAdapter();
                      
            try {
                oConn = GetSqlConnection();
                
                if(oConn.State != ConnectionState.Open) {
                    oConn.Open();
                }

                //apply connection
                oCmd.Connection = oConn;
                oCmd.CommandTimeout = 600;
                oCmd.CommandType = CommandType.Text;

                //load adapter
                oAdapter.SelectCommand = oCmd;
                            } 
            catch(SqlException sqex)
            {
                throw new Exception(sqex.GetBaseException().ToString());
            } 
            finally 
            {                
                if(oConn != null) 
                {
                    //make sure the connection is not already closed
                    if(oConn.State != ConnectionState.Closed)
                    {
                        oConn.Close();
                    }
                }
            }            
            return oAdapter;
        }
        #endregion        
    }
}
